// Лаборатория электроники и программирования
// Эксперимент 49
// Запись в файл на SD-карте  
// данных, поступающих по последовательному порту
//

// подключение библиотек
#include <SPI.h>
#include <SD.h>
// экземпляр объекта 
File file1;
// пин CS
int pinCS = 10;
// данные, пришедшие из последовательного порта
String inputString = "";        
// строка пришла
boolean stringComplete = false;  

void setup() {
    // запуск последовательного порта 
    Serial.begin(9600);
   // резервирование 50 bytes для inputString:
   inputString.reserve(50);
   // инициализация карты
   Serial.print("Initializing SD card...");
   pinMode(10, OUTPUT);
   if (!SD.begin(pinCS)) {
      Serial.println("initialization failed!");
      return;
  }
  Serial.println("initialization done."); 
}

void loop() {
    // проверка прихода строки из последовательного порта
    if (stringComplete) {
       Serial.println(inputString);
       // запись строки в файл
       // открыть файл для записи
       file1 = SD.open("serial.txt", FILE_WRITE);
       if (file1) {
          Serial.println("Writing to serial.txt");
          file1.print(inputString);
          // закрыть файл
          file1.close();
       }
       else {
           Serial.println("Error open serial.txt");
       }
       // Чтение содержимого файла
       file1 = SD.open("serial.txt");
       if (file1) {
          Serial.println("Writing to serial.txt");
          // чтение файла:
          while (file1.available()) {
             Serial.write(file1.read());
          }
          // закрыть файл
          file1.close();
       }
       else {
           Serial.println("Error open serial.txt");
       }
       // очистить строку
       inputString = "";
       stringComplete = false;
    }

}

// 
void serialEvent() {
  boolean flag1=false;
  
  while (Serial.available() && flag1==false) {
    // получить байт:
    char inChar = (char)Serial.read();
    if (inChar == '\n') {
      stringComplete = true;
      flag1=true;
    }
    // добавление в строку
    inputString += inChar;
  }
}
